import HttpResponse from './http.response';
type Interceptor = (config: RequestInit) => RequestInit;
type ResponseInterceptor = (response: Response) => Response;
declare class HttpClient {
    protected baseURL: string;
    protected timeout: number;
    protected retries: number;
    private authToken;
    private serviceSecret;
    private requestInterceptors;
    private responseInterceptors;
    private loggingEnabled;
    private responseLoggingEnabled;
    constructor(baseURL: string, timeout?: number, retries?: number);
    setAuthToken(token: string): void;
    setServiceSecret(secret: string): void;
    enableLogging(): void;
    enableResponseLogging(): void;
    addRequestInterceptor(interceptor: Interceptor): void;
    addResponseInterceptor(interceptor: ResponseInterceptor): void;
    private applyRequestInterceptors;
    private applyResponseInterceptors;
    private logRequest;
    private handleResponse;
    private handleError;
    request(method: string, endpoint: string, data?: any, config?: any): Promise<HttpResponse<any> | undefined>;
    upload(endpoint: string, file: File, config?: any): Promise<HttpResponse<any>>;
    download(endpoint: string, config?: any): Promise<Blob>;
    get(endpoint: string, config?: any): Promise<HttpResponse<any> | undefined>;
    post(endpoint: string, data: any, config?: any): Promise<HttpResponse<any> | undefined>;
    put(endpoint: string, data: any, config?: any): Promise<HttpResponse<any> | undefined>;
    delete(endpoint: string, config?: any): Promise<HttpResponse<any> | undefined>;
}
export default HttpClient;
//# sourceMappingURL=http.client.d.ts.map